apiVersion: v1
kind: ConfigMap
metadata:
  name: nginx-conf
  namespace: reconstruct
data:
  nginx.conf: |
    error_log  /var/log/nginx/error.log;
    events {}
    
    http {
      client_max_body_size 100M;
      proxy_read_timeout 1000;
      proxy_send_timeout 1000;
      upstream backend {
          server openmvgremote.reconstruct.svc.cluster.local:5000 max_fails=3 fail_timeout=60s ;
          server openmvg.reconstruct.svc.cluster.local:5000 backup;
      }
      resolver 127.0.0.1 valid=10s;
      server {
        
        listen 80;
          location / {
              set $backend_servers backend;
              proxy_pass http://$backend_servers;
              proxy_connect_timeout 5s;
              proxy_read_timeout 1000s;
              proxy_send_timeout 1000s;
              send_timeout 1000;
          }
      }
    }
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: nginx
  namespace: reconstruct
spec:
  replicas: 1
  selector: 
    matchLabels: 
      app: nginx
  template:
    metadata:
      labels:
        app: nginx
    spec:
      containers:
      - name: nginx
        image: nginx
        ports:
        - containerPort: 80
        volumeMounts:
        - mountPath: /etc/nginx # mount nginx-conf volumn to /etc/nginx
          readOnly: true
          name: nginx-conf
      volumes:
      - name: nginx-conf
        configMap:
          name: nginx-conf # place ConfigMap `nginx-conf` on /etc/nginx
          items:
            - key: nginx.conf
              path: nginx.conf

---
apiVersion: v1
kind: Service
metadata:
  name: nginx
  namespace: reconstruct
spec:
  type: ClusterIP
  ports:
  - port: 80
    targetPort: 80
  selector:
    app: nginx